; Copyright (c) 2021, rrc-open-firmware FM10K-Documentation Contributors
;
; Redistribution and use in source and binary forms, with or without
; modification, are permitted provided that the following conditions are met:
;
;     * Redistributions of source code must retain the above copyright notice,
;       this list of conditions and the following disclaimer.
;     * Redistributions in binary form must reproduce the above copyright
;       notice, this list of conditions and the following disclaimer in the
;       documentation and/or other materials provided with the distribution.
;     * Neither the name of the copyright holder nor the names of its contributors
;       may be used to endorse or promote products derived from this software
;       without specific prior written permission.
;
; THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
; AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
; IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
; DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
; FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
; DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
; SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
; CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
; OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
; OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


; FASTCALL void(bool pep0, bool pep2, bool pep4, bool pep6)
init_setPcieSplitMode:
    SET DEVICE_CFG, 0, 0xf ; Reset PCIe modes PCIeMode[0..3]
    BEQ P0, 0, 0x1, @.continue0  ; PEP0
        SET DEVICE_CFG, 0x1, 0x1 ; Set PCIeMode[0] = 1 (4x4x4x4)
    .continue0:

    BEQ P1, 0, 0x1, @.continue2  ; PEP2
        SET DEVICE_CFG, 0x2, 0x2 ; Set PCIeMode[1] = 1 (4x4x4x4)
    .continue2:

    BEQ~3 P2, 0, 0x1, @.continue4  ; access POPP 1 PEP4
        SET DEVICE_CFG, 0x4, 0x4 ; Set PCIeMode[2] = 1 (4x4x4x4)
    .continue4:

    BEQ~3 P3, 0, 0x1, @.continue6  ; access POPP 2 PEP6
        SET DEVICE_CFG, 0x8, 0x8 ; Set PCIeMode[3] = 1 (4x4x4x4)
    .continue6:
    RET

; FASTCALL void(bool pep0, bool pep1, bool pep2, bool pep3, bool pep4, bool pep5, bool pep6, bool pep7, bool pep8)
init_setPciePEPEnabled:
    BEQ P0, 1, 0x1, @.continue0    ; PEP0
         SET DEVICE_CFG, 0, 0x0080 ; Set PCIEnable[0] = 0, default 1
    .continue0:

    BEQ P1, 1, 0x1, @.continue1    ; PEP1
         SET DEVICE_CFG, 0, 0x0100 ; Set PCIEnable[1] = 0, default 1
    .continue1:

    BEQ~3 P2, 1, 0x1, @.continue2    ; PEP2
         SET DEVICE_CFG, 0, 0x0200 ; Set PCIEnable[2] = 0, default 1
    .continue2:

    BEQ~3 P3, 1, 0x1, @.continue3    ; PEP3
         SET DEVICE_CFG, 0, 0x0400 ; Set PCIEnable[3] = 0, default 1
    .continue3:

    BEQ~3 P4, 1, 0x1, @.continue4    ; PEP4
         SET DEVICE_CFG, 0, 0x0800 ; Set PCIEnable[4] = 0, default 1
    .continue4:

    BEQ~3 P5, 1, 0x1, @.continue5    ; PEP5
         SET DEVICE_CFG, 0, 0x1000 ; Set PCIEnable[5] = 0, default 1
    .continue5:

    BEQ~3 P6, 1, 0x1, @.continue6    ; PEP6
         SET DEVICE_CFG, 0, 0x2000 ; Set PCIEnable[6] = 0, default 1
    .continue6:

    BEQ~3 P7, 1, 0x1, @.continue7    ; PEP7
         SET DEVICE_CFG, 0, 0x4000 ; Set PCIEnable[7] = 0, default 1
    .continue7:

    BEQ~3 P8, 1, 0x1, @.continue8    ; PEP8
         SET DEVICE_CFG, 0, 0x8000 ; Set PCIEnable[8] = 0, default 1
    .continue8:

    RET

lock_PCIE_SBUS_release:
    BNE api_PCIE_SBUS_LOCK_STATE, 1, 0x3, @.return ; If we hold the lock
        SET api_PCIE_SBUS_LOCK_STATE, 0, 0x3 ; Release lock
    .return:
    RET